=== debian/changelog ===
open3d (0.14.1+dfsg-7build3) jammy; urgency=medium

  * No-change rebuild for libtbb soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 10:08:48 +0100

open3d (0.14.1+dfsg-7build2) jammy; urgency=medium

  * No change rebuild to pick up de-LTO-ed libimgui-dev. 

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 08 Mar 2022 22:37:14 +1300

open3d (0.14.1+dfsg-7build1) jammy; urgency=medium

  * No change rebuild as libdraco3 was replaced by libdraco4

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 24 Feb 2022 14:03:31 +0000

open3d (0.14.1+dfsg-7) unstable; urgency=medium

  * Add workaround for missing TBBConfig.cmake on some arch

 -- Timo Röhling <roehling@debian.org>  Sun, 20 Feb 2022 14:57:15 +0100

open3d (0.14.1+dfsg-6) unstable; urgency=medium

  * Remove version restriction on Python

 -- Timo Röhling <roehling@debian.org>  Sat, 12 Feb 2022 08:57:11 +0100

open3d (0.14.1+dfsg-5) unstable; urgency=medium

  * Fix autopkgtest

 -- Timo Röhling <roehling@debian.org>  Fri, 11 Feb 2022 19:58:01 +0100

open3d (0.14.1+dfsg-4) unstable; urgency=medium

  * Upload to unstable
  * Fix ImGui assertion about empty IDs on menu draw
  * Disable LTO for Open3D library.
    Open3D has some fragile static initialization dependencies across
    translation units which break with link time optimization.

 -- Timo Röhling <roehling@debian.org>  Fri, 11 Feb 2022 00:36:32 +0100

open3d (0.14.1+dfsg-3) experimental; urgency=medium

  * Fix -arch/-indep build separation

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Feb 2022 16:16:25 +0100

open3d (0.14.1+dfsg-2) experimental; urgency=medium

  * Fix FTBFS with libfmt 8

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Feb 2022 13:40:16 +0100

open3d (0.14.1+dfsg-1) experimental; urgency=medium

  * New upstream version 0.14.1+dfsg

 -- Timo Röhling <roehling@debian.org>  Fri, 07 Jan 2022 20:26:03 +0100

open3d (0.13.0+dfsg-1) experimental; urgency=medium

  * New upstream version 0.13.0+dfsg

 -- Timo Röhling <roehling@debian.org>  Thu, 28 Oct 2021 23:20:58 +0200

open3d (0.9.0+ds-7) unstable; urgency=medium

  * Add -Wno-psabi to autopkgtest (Closes: #996278)

 -- Timo Röhling <roehling@debian.org>  Wed, 13 Oct 2021 00:23:55 +0200

open3d (0.9.0+ds-6) unstable; urgency=medium

  * Allow legacy OpenGL for systems without GLX
  * Ensure that python3-open3d depends on python3-numpy (Closes: #993622)
  * Update maintainer info
  * Bump Standards-Version to 4.6.0 (no changes)

 -- Timo Röhling <roehling@debian.org>  Sat, 04 Sep 2021 00:43:50 +0200
