=== debian/tests/control ===
Tests: test-cpp test-py
Depends: libopen3d-dev, python3-open3d, python3-numpy, cmake, g++ | c++-compiler
Restrictions: superficial
